using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;

namespace RegionalTest
{
    public partial class Form1 : Form
    {
        string formatString = string.Empty;

        public Form1()
        {
            InitializeComponent();

            this.formatString = this.textBox1.Text;
            this.comboBox1.SelectedIndex = 0;
        }

        private void gridControl1_PrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventArgs e)
        {
            if (e.ColIndex == 2 && e.RowIndex == 2)
            {
                try
                {
                    e.Style.ParseString(this.formatString);
                }
                catch (Exception ex)
                {
                    System.Diagnostics.Debug.Fail(ex.Message, ex.StackTrace);
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.formatString = this.textBox1.Text;
        }

        private void gridControl1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
        {
            if (e.ColIndex == 2 && e.RowIndex == 1)
            {
                DateTime date = new DateTime(2007, 7, 22);
                e.Style.Text = date.ToString();
                e.Handled = true;
            }
            else if (e.ColIndex == 2 && e.RowIndex == 2)
            {
                e.Style.Text = "Text color is white, background is blue";               
                e.Handled = true;
            }
        }

        //protected override void WndProc(ref Message m)
        //{
        //    int WM_SETTINGSCHANGE = 0x001A;

        //    if (m.Msg == WM_SETTINGSCHANGE)
        //    {
        //        System.Threading.Thread.CurrentThread.CurrentCulture.ClearCachedData();
        //        System.Threading.Thread.CurrentThread.CurrentUICulture.ClearCachedData();

        //        this.Refresh();
        //    }
        //    base.WndProc(ref m);
        //}

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            string code = this.comboBox1.Items[this.comboBox1.SelectedIndex].ToString();

            if (code != string.Empty)
            {
                CultureInfo newculture = new CultureInfo(code);
                System.Threading.Thread.CurrentThread.CurrentCulture = newculture;
                this.Refresh();
            }
        }
    }
}